"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.quickSelect = void 0;
const _swapInPlace_1 = require("./_swapInPlace");
const quickSelect = (data, index, compareFn) => index < 0 || index >= data.length
    ?
        undefined
    : quickSelectImplementation([...data], 0, data.length - 1, index, compareFn);
exports.quickSelect = quickSelect;
function quickSelectImplementation(data, left, right, index, compareFn) {
    if (left === right) {
        return data[left];
    }
    const pivotIndex = partition(data, left, right, compareFn);
    return index === pivotIndex
        ?
            data[index]
        : quickSelectImplementation(data, index < pivotIndex ? left : pivotIndex + 1, index < pivotIndex ? pivotIndex - 1 : right, index, compareFn);
}
function partition(data, left, right, compareFn) {
    const pivot = data[right];
    let i = left;
    for (let j = left; j < right; j++) {
        if (compareFn(data[j], pivot) < 0) {
            (0, _swapInPlace_1.swapInPlace)(data, i, j);
            i += 1;
        }
    }
    (0, _swapInPlace_1.swapInPlace)(data, i, right);
    return i;
}
