"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports._reduceLazy = void 0;
function _reduceLazy(array, lazy) {
    const out = [];
    for (const [index, item] of array.entries()) {
        const result = lazy(item, index, array);
        if (result.hasMany === true) {
            out.push(...result.next);
        }
        else if (result.hasNext) {
            out.push(result.next);
        }
        if (result.done) {
            break;
        }
    }
    return out;
}
exports._reduceLazy = _reduceLazy;
