"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.conditional = void 0;
const _purryOn_1 = require("./_purryOn");
function conditional(...args) {
    return (0, _purryOn_1.purryOn)(isCase, conditionalImplementation, args);
}
exports.conditional = conditional;
function conditionalImplementation(data, ...cases) {
    for (const [when, then] of cases) {
        if (when(data)) {
            return then(data);
        }
    }
    throw new Error("conditional: data failed for all cases");
}
function isCase(maybeCase) {
    if (!Array.isArray(maybeCase)) {
        return false;
    }
    const [when, then, ...rest] = maybeCase;
    return (typeof when === "function" &&
        when.length <= 1 &&
        typeof then === "function" &&
        then.length <= 1 &&
        rest.length === 0);
}
(function (conditional) {
    conditional.defaultCase = (then = trivialDefaultCase) => [() => true, then];
})(conditional || (exports.conditional = conditional = {}));
const trivialDefaultCase = () => undefined;
