"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.evolve = void 0;
const entries_1 = require("./entries");
const purry_1 = require("./purry");
function evolve(...args) {
    return (0, purry_1.purry)(_evolve, args);
}
exports.evolve = evolve;
function _evolve(data, evolver) {
    if (typeof data !== "object" || data === null) {
        return data;
    }
    const out = { ...data };
    for (const [key, value] of (0, entries_1.entries)(evolver)) {
        if (key in out) {
            out[key] =
                typeof value === "function"
                    ? value(out[key])
                    : _evolve(out[key], value);
        }
    }
    return out;
}
