"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.firstBy = void 0;
const _purryOrderRules_1 = require("./_purryOrderRules");
const hasAtLeast_1 = require("./hasAtLeast");
function firstBy(...args) {
    return (0, _purryOrderRules_1.purryOrderRules)(firstByImplementation, args);
}
exports.firstBy = firstBy;
function firstByImplementation(data, compareFn) {
    if (!(0, hasAtLeast_1.hasAtLeast)(data, 2)) {
        return data[0];
    }
    let [currentFirst] = data;
    const [, ...rest] = data;
    for (const item of rest) {
        if (compareFn(item, currentFirst) < 0) {
            currentFirst = item;
        }
    }
    return currentFirst;
}
