"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.flatMap = void 0;
const purry_1 = require("./purry");
function flatMap(...args) {
    return (0, purry_1.purry)(flatMapImplementation, args, lazyImplementation);
}
exports.flatMap = flatMap;
const flatMapImplementation = (data, callbackfn) => data.flatMap(callbackfn);
const lazyImplementation = (callbackfn) => (value, index, data) => {
    const next = callbackfn(value, index, data);
    return Array.isArray(next)
        ? { done: false, hasNext: true, hasMany: true, next }
        : { done: false, hasNext: true, next };
};
