"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.groupBy = void 0;
const purry_1 = require("./purry");
function groupBy(...args) {
    return (0, purry_1.purry)(groupByImplementation, args);
}
exports.groupBy = groupBy;
const groupByImplementation = (data, callbackfn) => {
    const output = {};
    for (const [index, item] of data.entries()) {
        const key = callbackfn(item, index, data);
        if (key !== undefined) {
            let { [key]: items } = output;
            if (items === undefined) {
                items = [];
                output[key] = items;
            }
            items.push(item);
        }
    }
    return output;
};
