"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.mapWithFeedback = void 0;
const _reduceLazy_1 = require("./_reduceLazy");
const purry_1 = require("./purry");
function mapWithFeedback(...args) {
    return (0, purry_1.purry)(mapWithFeedbackImplementation, args, lazyImplementation);
}
exports.mapWithFeedback = mapWithFeedback;
const mapWithFeedbackImplementation = (data, reducer, initialValue) => (0, _reduceLazy_1._reduceLazy)(data, lazyImplementation(reducer, initialValue));
const lazyImplementation = (reducer, initialValue) => {
    let previousValue = initialValue;
    return (currentValue, index, data) => {
        previousValue = reducer(previousValue, currentValue, index, data);
        return { done: false, hasNext: true, next: previousValue };
    };
};
