"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.mergeDeep = void 0;
const isPlainObject_1 = require("./isPlainObject");
const purry_1 = require("./purry");
function mergeDeep(...args) {
    return (0, purry_1.purry)(mergeDeepImplementation, args);
}
exports.mergeDeep = mergeDeep;
function mergeDeepImplementation(destination, source) {
    const output = { ...destination, ...source };
    for (const key in source) {
        if (!(key in destination)) {
            continue;
        }
        const { [key]: destinationValue } = destination;
        if (!(0, isPlainObject_1.isPlainObject)(destinationValue)) {
            continue;
        }
        const { [key]: sourceValue } = source;
        if (!(0, isPlainObject_1.isPlainObject)(sourceValue)) {
            continue;
        }
        output[key] = mergeDeepImplementation(destinationValue, sourceValue);
    }
    return output;
}
