"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.takeFirstBy = void 0;
const _heap_1 = require("./_heap");
const _purryOrderRules_1 = require("./_purryOrderRules");
function takeFirstBy(...args) {
    return (0, _purryOrderRules_1.purryOrderRulesWithArgument)(takeFirstByImplementation, args);
}
exports.takeFirstBy = takeFirstBy;
function takeFirstByImplementation(data, compareFn, n) {
    if (n <= 0) {
        return [];
    }
    if (n >= data.length) {
        return [...data];
    }
    const heap = data.slice(0, n);
    (0, _heap_1.heapify)(heap, compareFn);
    const rest = data.slice(n);
    for (const item of rest) {
        (0, _heap_1.heapMaybeInsert)(heap, compareFn, item);
    }
    return heap;
}
