import { purry } from "./purry";
export function flatMap(...args) {
    return purry(flatMapImplementation, args, lazyImplementation);
}
const flatMapImplementation = (data, callbackfn) => data.flatMap(callbackfn);
const lazyImplementation = (callbackfn) => (value, index, data) => {
    const next = callbackfn(value, index, data);
    return Array.isArray(next)
        ? { done: false, hasNext: true, hasMany: true, next }
        : { done: false, hasNext: true, next };
};
