import { isDeepEqual } from "./isDeepEqual";
import { purry } from "./purry";
export function hasSubObject(...args) {
    return purry(_hasSubObject, args);
}
function _hasSubObject(data, subObject) {
    for (const key of Object.keys(subObject)) {
        if (!Object.prototype.hasOwnProperty.call(data, key)) {
            return false;
        }
        if (!isDeepEqual(subObject[key], data[key])) {
            return false;
        }
    }
    return true;
}
