import { _reduceLazy } from "./_reduceLazy";
import { purry } from "./purry";
export function mapWithFeedback(...args) {
    return purry(mapWithFeedbackImplementation, args, lazyImplementation);
}
const mapWithFeedbackImplementation = (data, reducer, initialValue) => _reduceLazy(data, lazyImplementation(reducer, initialValue));
const lazyImplementation = (reducer, initialValue) => {
    let previousValue = initialValue;
    return (currentValue, index, data) => {
        previousValue = reducer(previousValue, currentValue, index, data);
        return { done: false, hasNext: true, next: previousValue };
    };
};
