import { isPlainObject } from "./isPlainObject";
import { purry } from "./purry";
export function mergeDeep(...args) {
    return purry(mergeDeepImplementation, args);
}
function mergeDeepImplementation(destination, source) {
    const output = { ...destination, ...source };
    for (const key in source) {
        if (!(key in destination)) {
            continue;
        }
        const { [key]: destinationValue } = destination;
        if (!isPlainObject(destinationValue)) {
            continue;
        }
        const { [key]: sourceValue } = source;
        if (!isPlainObject(sourceValue)) {
            continue;
        }
        output[key] = mergeDeepImplementation(destinationValue, sourceValue);
    }
    return output;
}
