import { purry } from "./purry";
export function setPath(...args) {
    return purry(_setPath, args);
}
export function _setPath(data, path, value) {
    const [current, ...rest] = path;
    if (current === undefined) {
        return value;
    }
    if (Array.isArray(data)) {
        return data.map((item, index) => index === current ? _setPath(item, rest, value) : item);
    }
    if (data === null || data === undefined) {
        throw new Error("Path doesn't exist in object!");
    }
    return {
        ...data,
        [current]: _setPath(data[current], rest, value),
    };
}
