import { _reduceLazy } from "./_reduceLazy";
import { purry } from "./purry";
export function take(...args) {
    return purry(takeImplementation, args, lazyImplementation);
}
const takeImplementation = (array, n) => _reduceLazy(array, lazyImplementation(n));
function lazyImplementation(n) {
    if (n <= 0) {
        return () => ({ done: true, hasNext: false });
    }
    let remaining = n;
    return (value) => {
        remaining -= 1;
        return { done: remaining <= 0, hasNext: true, next: value };
    };
}
