import { _reduceLazy } from "./_reduceLazy";
import { purry } from "./purry";
export function unique(...args) {
    return purry(uniqueImplementation, args, lazyImplementation);
}
const uniqueImplementation = (array) => _reduceLazy(array, lazyImplementation());
function lazyImplementation() {
    const set = new Set();
    return (value) => {
        if (set.has(value)) {
            return { done: false, hasNext: false };
        }
        set.add(value);
        return { done: false, hasNext: true, next: value };
    };
}
