export function zipWith(arg0, arg1, arg2) {
    if (typeof arg0 === "function") {
        return arg1 === undefined
            ? (f, s) => zipWithImplementation(f, s, arg0)
            : (f) => zipWithImplementation(f, arg1, arg0);
    }
    if (arg1 === undefined || arg2 === undefined) {
        throw new Error("zipWith: Missing arguments in dataFirst function call");
    }
    return zipWithImplementation(arg0, arg1, arg2);
}
function zipWithImplementation(first, second, fn) {
    const datum = [first, second];
    const resultLength = first.length > second.length ? second.length : first.length;
    const result = [];
    for (let i = 0; i < resultLength; i++) {
        result.push(fn(first[i], second[i], i, datum));
    }
    return result;
}
