/**
 * Compute the product of the numbers in the array, or return 1 for an empty
 * array.
 *
 * @param data - The array of numbers.
 * @signature
 *   R.product(data);
 * @example
 *   R.product([1, 2, 3]); // => 6
 *   R.product([]); // => 1
 * @dataFirst
 * @category Number
 */
export declare function product<T extends ReadonlyArray<bigint> | ReadonlyArray<number>>(data: T): T[number];
/**
 * Compute the product of the numbers in the array, or return 1 for an empty
 * array.
 *
 * @signature
 *   R.product()(data);
 * @example
 *   R.pipe([1, 2, 3], R.product()); // => 6
 *   R.pipe([], R.product()); // => 1
 * @dataLast
 * @category Number
 */
export declare function product(): <T extends ReadonlyArray<bigint> | ReadonlyArray<number>>(data: T) => T[number];
//# sourceMappingURL=product.d.ts.map